ANSEI_LIBRARY = File.expand_path(File.dirname(__FILE__))
$LOAD_PATH.unshift(ANSEI_LIBRARY) unless $LOAD_PATH.include?(ANSEI_LIBRARY)

require 'coffee-script'
require 'erubis'
require 'fileutils'
require 'redcarpet'
require 'sass'
require 'tilt'
require 'yaml'

require_relative 'ansei/fileinfo'
require_relative 'ansei/render'
require_relative 'ansei/shehai'
require_relative 'ansei/utils'

# Base module for Ansei
module Ansei
  class << self
    attr_accessor :config

    # Build site from source files
    def shehai
      set_config
      set_directories

      Shehai.new.build
    end

    protected

    # Setup Ansei with standard configuration
    def set_config
      yaml = File.read("#{ANSEI_LIBRARY}/ansei.yml")
      yaml = Utils.string_to_yaml(yaml, false)

      yaml[:regex].each do |key, value|
        yaml[:regex][key] = Regexp.new(value)
      end

      @config = yaml
    end

    # Set all of the working directories
    def set_directories
      @config[:cwd] = Dir.pwd

      build = "#{config[:cwd]}/build"
      source = "#{config[:cwd]}/source"

      @config[:directories] = {
        build:       build,
        javascript:  ["#{source}/javascript",  'assets/js'],
        markdown:    ["#{source}/markdown",    ''],
        stylesheets: ["#{source}/stylesheets", 'assets/css'],
        templates:   ["#{source}/templates",   '']
      }
    end
  end
end
